% Preprocessing

function [I] = simple_preprocessor(I,kernelWidth)

% I_orig = I;
% min value subtraction
% figure;imshow(I)
% length(I,2)

% if xd==3
%     I = max(I, [], 3);
% end
% I = rgb2gray(I);
if ndims(I)==3
    xd = size(I,3);
    for i=1:xd
        I(:,:,i) = imadjust(I(:,:,i));
    end
else
    I = imadjust(I);
end
% figure;imshow(I)

% gaussian blur
kernelRadius = ceil(kernelWidth);
kernelLength = (2 * kernelRadius ) + 1;
mGaussianKernel = fspecial('gaussian',...
    [kernelLength, kernelLength], kernelRadius);
I = imfilter(I,mGaussianKernel,'same');
% figure;imshow(I)
minInt = mean(I(:));
I = abs(I-minInt);


% figure;imshow(I)

% 
% se = strel('arbitrary',8);        
% erodedBW = imerode(I,se);
% figure;imshow(I)
% 
% I = imfill(erodedBW,'holes');
% figure;imshow(I)
end
