function [ I ] = simple_advWatershed( I,thresholdfactor,imextendedParam )
D = -bwdist(~I);
% figure(), imshow(D,[])
% mask = imregionalmax(D,8);
mask = imextendedmin(D,imextendedParam,8);
% figure(), imshowpair(I,mask,'blend')

D2 = imimposemin(D,mask);
Ld2 = watershed(D2);
% rgb = label2rgb(Ld2, 'jet', [.5 .5 .5]);
% figure(), imshow(rgb);

bw3 = I;
bw3(Ld2 == 0) = 0;
I = bw3;

% figure(), imshow(I)
level = graythresh(I);
if ndims(I)==3
    xd = size(I,3);
    for i=1:xd
        I(:,:,i) = im2bw(I(:,:,i),level/thresholdfactor);
    end
else
    I = im2bw(I,level/thresholdfactor);
end
% figure(), imshow(I)

% remove all object containing fewer than 20 pixels
I = bwareaopen(I,10);
I = imfill(I,'holes');
% if ndims(I)==3
%     xd = size(I,3);
%     for i=1:xd
%         I(:,:,i) = bwconvhull(I(:,:,i),'objects');
%     end
% else
%     I = bwconvhull(I,'objects');
% end
%% Fluo-N2DH-GOWT1




% % separate objects that might be glued to each other after convex hull
% se = strel('disk',3);
% I = imerode(I,se);
% D = -bwdist(~I);
% % figure(), imshow(D,[])
% %mask = imregionalmax(D,4);
% mask = imextendedmin(D,imextendedParam,8);
% % figure(), imshowpair(I,mask,'blend')
%
% D2 = imimposemin(D,mask);
% Ld2 = watershed(D2);
% % rgb = label2rgb(Ld2, 'jet', [.5 .5 .5]);
% % figure(), imshow(rgb);
% level = graythresh(I);
% I = im2bw(I,level/thresholdfactor);
% bw3 = I;
% bw3(Ld2 == 0) = 0;
% I=bw3;
% I = imfill(I,'holes');
% I = bwconvhull(I,'objects');
% I = bwareaopen(I,10);

end
